# Contribute
First, thank you for considering contributing to dep! Here is a guide to help you understand how dep has been developing by people.

## Bug report
When you find issues, please report them:
+ https://github.com/depjs/dep/issues/new

Be sure to follow the issue template.

## Feature request
We're trying to find out the bare minimum features for end users. That means it is very reluctant to add new features, but having a discussion is useful for clarifying the minimum definitions.

Feel free to ask us in #dep-js on https://package.community/ or on [twitter].

## Make a patch
1. Development process:
  + if it's bug fix: making a patch first is great
  + if it's feature request: let's disscuss first
2. Be sure your patch passes `npm test`
3. Commit message should follow [standard-version][]

## Tips

### Your First Contribution

Working on your first Pull Request? You can learn how from this *free* series, [How to Contribute to an Open Source Project on GitHub][].


### Submitting code

Any code change should be submitted as a pull request. The description should explain what the code does and give steps to execute it. The pull request should also contain tests.

### Code review process

The bigger the pull request, the longer it will take to review and merge. Try to break down large pull requests in smaller chunks that are easier to review and merge. It is also always helpful to have some context for your pull request. What was the purpose? Why does it matter to you?

[standard-version]: https://github.com/conventional-changelog/standard-version
[How to Contribute to an Open Source Project on GitHub]: https://egghead.io/series/how-to-contribute-to-an-open-source-project-on-github
